﻿package {
	
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.media.Sound;
	import flash.media.SoundMixer;
	import flash.media.SoundChannel;
	import flash.net.URLRequest;
	import flash.utils.ByteArray;
	import flash.geom.Rectangle;
	
	public class Spectre extends Sprite{   
	
		
		private var _son:Sound;
		private var _canal:SoundChannel;
		private var _grapheSpectre:BitmapData;
		private var tableauGauche:Array = new Array();
		private var tableauDroit:Array = new Array();
		private var colorArray:Array = new Array();
				private var colorArray2:Array = new Array();

		public function Spectre(sound:String){
			_grapheSpectre = new BitmapData( 600, 600, false, 0x000000 );
			var bitmap:Bitmap = new Bitmap( _grapheSpectre );
			addChild( bitmap );
			bitmap.x = 0;
			bitmap.y = 0;
			
			tableauGauche.length = 256;
			colorArray = [0x6F6F6F,0xD90000,0x01B0F0,0xAEEE00,0xFF358B,0x01B0F0,0xAEEE00,0x2E0927,0xD90000,0xFF2D00,0xFF8C00]
			colorArray2 = [0xFFFFFF,0xFF358B,0x01B0F0,0xAEEE00,0xFF358B,0x01B0F0,0xAEEE00,0x2E0927,0xD90000,0xFF2D00,0xFF8C00]
			_son = new Sound(new URLRequest(sound));
			_canal = _son.play();
		
			addEventListener(Event.ENTER_FRAME, onEnterFrame);		
		}
		
		private function onEnterFrame(evenement:Event):void{
			//Crée le tableau d'octets et le remplit de données
			var spectre:ByteArray = new ByteArray();
			
			SoundMixer.computeSpectrum(spectre);
			const MAXPOINT:Number = 40;
			//Effacer le bitmap
			_grapheSpectre.fillRect(_grapheSpectre.rect,0x00000000);
			
			_piniX = 0;
			_piniY = 300;
			
			//Canal gauche
			var _pActuG:Number
			for(var i:int=0;i<256;i++){
				_pActuG= _piniY - tableauGauche[i];
				//5 steps back
					tableauGauche[i] = spectre.readFloat() * 210;
				
				
				//_rect = new Rectangle(_piniX + ( i *2), _pActuG, 20-tableauGauche[i], 2);
				//_grapheSpectre.fillRect(_rect, 0xff0000);
				for (var icloud:int=0;icloud<MAXPOINT;icloud++){
						_rect1 = new Rectangle((_piniX + i *3)+Math.random()*100-50, _pActuG+Math.random()*70-35,2,2);
						_grapheSpectre.fillRect(_rect1,colorArray[0]);
						
					}
					
			
				//_grapheSpectre.setPixel32(_piniX + ( i *2), _pActuG,0xfff00fff);
				//_grapheSpectre.setPixel32( (_piniX +0)+ ( (256-i) * 2), _pActuG,0xff000000);
				
				//_rect = new Rectangle( _piniX + ( (256-i) * 2), _pActuG, 20-tableauGauche[i], 2);
				

				
			}
			for(var i:int=0;i<256;i++){
				_pActuG= _piniY - tableauGauche[i];
				//5 steps back
				tableauGauche[i] = spectre.readFloat() * 210;
				for (var icloud:int=0;icloud<MAXPOINT;icloud++){
				_rect2 = new Rectangle((_piniX + (256-i) * 3)+Math.random()*50-25, _pActuG+Math.random()*70-35,2,2);
				_grapheSpectre.fillRect(_rect2,colorArray2[0]);

					}
			}
		
		}
	}
	
}